%define nhgamedir %{_libdir}/games/nethackdir
%define nhdatadir %{_localstatedir}/lib/games/nethack
%define with_tty  %{!?_without_tty:1}%{?_without_tty:0}

Name:           nethack-falconseye
Version:        1.9.4
Release:        0.fdr.4.a.2
Epoch:          0
Summary:        NetHack - Falcon's Eye

Group:          Amusements/Games
License:        NetHack General Public License
URL:            http://www.hut.fi/~jtpelto2/nethack.html
Source0:   http://cage.rug.ac.be/~jdemeyer/nethack/nethack-341-jtp-194a.tar.bz2
Source1:        %{name}.desktop
Patch0:         %{name}-config.patch
Patch10:        %{name}-C341-31.patch
Patch11:  http://www.argon.org/~roderick/nethack/nethack-3.4.1-rtld-next.1.diff
Patch12:        http://www.netsonic.fi/~walker/nh/c341-2.diff
Patch13:        http://www.netsonic.fi/~walker/nh/c341-53.diff
Patch14:        http://post.queensu.ca/~lehotay/C341-13.diff

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  SDL-devel >= 0:1.2.2, byacc, flex, desktop-file-utils
BuildRequires:  ImageMagick
%if %{with_tty}
BuildRequires:  ncurses-devel
%endif
Requires:       /usr/bin/timidity, /usr/bin/bzip2
Provides:       nethack = %{epoch}:3.4.1

%description
Falcon's Eye is a mouse-driven interface for NetHack that enhances the
visuals, audio and accessibility of the game, yet retains all the
original gameplay and game features.

See %{_docdir}/%{name}-%{version}/nethack.rc and
%{nhgamedir}/defaults.nh for examples
of your personal ~/.nethackrc, and the system-wide configuration in
%{nhgamedir}/config.

Use the "--without tty" option to rpmbuild if you wish to compile a
version without TTY support.


%prep
%setup -q -n nethack-341-jtp-194a
%patch0 -p1
cd src
%patch10 -p0
cd -
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1

perl -pi -e \
  's|/usr/games/lib/nethackdir\b|%{nhgamedir}|g' \
  doc/nethack.6 \
  doc/nethack.txt \
  doc/recover.6 \
  doc/recover.txt \
  include/config.h

perl -pi -e \
  's|^.*(\#define\s+VAR_PLAYGROUND\s).+$|${1}"%{nhdatadir}"|' \
  include/unixconf.h

perl -pi -e 's|^(\#define\s+JTP_LOG_FILENAME\s+\")[^\"]+(\".*)$|${1}%{_localstatedir}/log/nethack/jtp_log.txt${2}|' win/jtp/jtp_gen.c

%if %{with_tty}
perl -pi -e 's|^.*(\#define\s+TTY_GRAPHICS).*$|$1|' include/config.h
perl -pi -e \
  's|^(WINSRC\s*=\s*)(.+)$|$1\$(WINTTYSRC) $2|;
   s|^(WINOBJ\s*=\s*)(.+)$|$1\$(WINTTYOBJ) $2|;
   s|^(WINLIB\s*=\s*)(.+)$|$1\$(WINTTYLIB) $2|' \
  sys/unix/Makefile.src
%endif

# Fix line terminators of config and text files.
perl -pi -e 's|\r\n|\n|g' win/jtp/gamedata/*.txt win/jtp/gamedata/config/*.txt


%build
sh ./sys/unix/setup.sh links
make all # -j > 1 doesn't work here
make %{?_smp_mflags} -C util recover dlb
convert win/jtp/nethack.ico nethack.png


%install
rm -rf $RPM_BUILD_ROOT

%makeinstall \
  CHOWN=/bin/true \
  CHGRP=/bin/true \
  GAMEDIR=$RPM_BUILD_ROOT%{nhgamedir} \
  VARDIR=$RPM_BUILD_ROOT%{nhdatadir} \
  SHELLDIR=$RPM_BUILD_ROOT%{_bindir} \
  JTPMANUALDIR=$(pwd)/manual \
  GAMEPERM=0755 \
  FILEPERM=0644 \
  EXEPERM=0755 \
  DIRPERM=0755

perl -pi -e "s|$RPM_BUILD_ROOT||" $RPM_BUILD_ROOT%{_bindir}/nethack

install -d -m 0755 $RPM_BUILD_ROOT%{_mandir}/man6
make -C doc MANDIR=$RPM_BUILD_ROOT%{_mandir}/man6 manpages

install -p -m 0755 util/recover util/dgn_comp util/lev_comp util/dlb \
  $RPM_BUILD_ROOT%{nhgamedir}

install -d -m 0775 $RPM_BUILD_ROOT%{_localstatedir}/log/nethack
> $RPM_BUILD_ROOT%{_localstatedir}/log/nethack/jtp_log.txt

ln -s %{nhgamedir}/license .

desktop-file-install \
  --vendor fedora \
  --mode 0644 \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category X-Fedora \
  %{SOURCE1}
install -D -p -m 0644 nethack.png \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/nethack-falconseye.png


%clean
rm -rf $RPM_BUILD_ROOT


%post
touch %{_localstatedir}/log/nethack/jtp_log.txt
chown root.games %{_localstatedir}/log/nethack/jtp_log.txt
chmod 0664 %{_localstatedir}/log/nethack/jtp_log.txt


%files
%defattr(-,root,root,-)
%doc doc/Guidebook doc/fixes* README manual falcon.txt license
%doc win/X11/nethack.rc win/jtp/gamedata/readme.txt
%{_bindir}/nethack
%dir %{nhgamedir}
%dir %{nhgamedir}/config
%{nhgamedir}/config/jtp_intr.txt
%{nhgamedir}/config/jtp_lit1.dat
%config %{nhgamedir}/config/jtp_keys.txt
%config %{nhgamedir}/config/jtp_opts.txt
%config %{nhgamedir}/config/jtp_snds.txt
%{nhgamedir}/[A-Zabdefghjklmopqrstvw]*
%{nhgamedir}/c[am]*
%{_mandir}/*/*
%{_datadir}/pixmaps/*
%{_datadir}/applications/*
%defattr(0664,root,games,0775)
%dir %{_localstatedir}/log/nethack
%ghost %{_localstatedir}/log/nethack/jtp_log.txt
%defattr(0660,root,games,0770)
%attr(2755,root,games) %{nhgamedir}/nethack
%config(noreplace) %{nhdatadir}


%changelog
* Sun Nov  2 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.4-0.fdr.4.a
- Add fix for bug C341-13.

* Sun Aug 17 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.4-0.fdr.3.a
- Drop NPTL patch, doesn't seem necessary with 1.9.4.
- Tightened file permissions, no setgid during install.
- Drop explicit stripping of the game binary (no setgid allows rpm to do it).
- Add fix for bug C341-53.
- Move manual to doc dir.

* Fri Jul 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.4-0.fdr.2.a
- Update to 1.9.4a.

* Sat Jul 12 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.4-0.fdr.2
- Approaching FHS (not quite there yet).

* Fri Jul 11 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.4-0.fdr.1
- Update to (unofficial) 1.9.4.
- Major spec and patch cleanup.
- Drop QT version.

* Sat Apr  5 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.3-0.fdr.3
- Require /usr/bin/timidity, the game doesn't work without a MIDI player.
- Fix Source0 URL (#15 comment 11).
- Save .spec in UTF-8.

* Sun Mar 23 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.3-0.fdr.2
- Use LD_ASSUME_KERNEL=2.2.5 in startup script (#15).
- Install icon to %%{_datadir}/pixmaps (#15).

* Sat Mar 22 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.9.3-0.fdr.1
- Update to current Fedora guidelines.

* Thu Feb 20 2003 Ville Skyttä <ville.skytta at iki.fi> - 1.9.3-1.fedora.1
- First Fedora release.

* Sat Oct 19 2002 Ville Skyttä <ville.skytta at iki.fi> 2:1.9.3-2cr
- Fix config dir permissions, thanks to roi for the heads up.

* Sun Oct  6 2002 Ville Skyttä <ville.skytta at iki.fi> 2:1.9.3-1cr
- Rebuild for Red Hat 8.0 using compat GCC.
- Add desktop icon.

* Sat Jun  8 2002 Ville Skyttä <ville.skytta at iki.fi> 2:1.9.3-0.1
- Rebuilt with RedHat 7.3.

* Thu May  2 2002 Ville Skyttä <ville.skytta at iki.fi> 1:1.9.3-cr4
- Added XFree86-devel build requirement.
- Rebuild with QT 2.3.2.
- Some spec cleanups.

* Fri Apr 19 2002 Ville Skyttä <ville.skytta at iki.fi> 1:1.9.3-cr3
- Added falconseye-savegame.patch, thanks to Patrick Gosling.
- Some specfile cleanups.

* Mon Nov 12 2001 Ville Skyttä <ville.skytta at iki.fi> 1.9.3-cr2
- added patches 1-5 (bugs C331-{4,30,51}, SC331-{3,4,6})
- better %doc handling

* Sun Nov 11 2001 Ville Skyttä <ville.skytta at iki.fi> 1.9.3-cr1
- removed explicit requirements for smoother experience on Mandrake; still
  need --nodeps to build on MDK, I guess
- added Serial to allow upgrade due to release tag change (vsX -> crX)
- tweaked %post and %postun to happen only on install and erase
- spec cleanups

* Sat Oct 27 2001 Ville Skyttä <ville.skytta at iki.fi> 1.9.3-vs10
- added ncurses-devel, byacc and flex to build requirements
- recompiled in redhat 7.2

* Tue Aug 21 2001 Ville Skyttä <ville.skytta at iki.fi>
- better config file handling
- recompiled with SDL-1.2.2-2 from rawhide
- release 1.9.3-vs9

* Wed Aug 15 2001 Ville Skyttä <ville.skytta at iki.fi>
- use mpg321 instead of mpg123 by default
- release 1.9.3-vs8

* Sat Jul 14 2001 Ville Skyttä <ville.skytta at iki.fi>
- recompiled with SDL-1.2.1-4
- release 1.9.3-vs7

* Wed Jul 11 2001 Ville Skyttä <ville.skytta at iki.fi>
- added some post-installation config notes (suggestion by Kormac)
- added some comments about KDE/artsd in jtp_opts.txt
- updated patch location again
- release 1.9.3-vs6

* Sun Jul  8 2001 Ville Skyttä <ville.skytta at iki.fi>
- updated patch location
- release 1.9.3-vs5
